/*
 * Arduino code for microstepper-project DDS-board
 * AW2021-09, see https://ohwr.org/project/microstepper
 * 
*/

#ifndef __PLLLIB_H__
#define __PLLLIB_H__

#include "Arduino.h"
#include "spibitbang.h"
#include "adf4350.h"
#include "printf_wrapper.h"
//#include "encoderlib.h"
//#include "FiniteStateMachine.h"

namespace ADF4350 {

class PLL {
  /*  
    experimental PLL control
    TT 2014-3-10
  */
public:
      PLL( int8_t DATA, int8_t LE, int8_t CLK)  {
        spi = new SPIBitBang(DATA, LE, CLK);
        //encoder = enc;
        //iter = 0;
        //numb = 2;
      };
      ~PLL() {
        delete spi;
      }
      

    
      // 10MHz ref in 1GHz out operation preset
      void preset1(){
        serial_printf("PLL preset1()\n");
        spi->write32_int32( ADF4350::preset1_R5 );
        spi->write32_int32( ADF4350::preset1_R4 );
        spi->write32_int32( ADF4350::preset1_R3 );
        spi->write32_int32( ADF4350::preset1_R2 );
        spi->write32_int32( ADF4350::preset1_R1 );
        spi->write32_int32( ADF4350::preset1_R0 );
        active = 1;
       }
      
      // 100MHz ref in 1GHz out operation preset
      void preset2(){
        serial_printf("PLL preset2()\n");
        spi->write32_int32( ADF4350::preset2_R5 );
        spi->write32_int32( ADF4350::preset2_R4 );
        spi->write32_int32( ADF4350::preset2_R3 );
        spi->write32_int32( ADF4350::preset2_R2 );
        spi->write32_int32( ADF4350::preset2_R1 );
        spi->write32_int32( ADF4350::preset2_R0 );
        active = 2;  
      }
      

      
private:
    SPIBitBang* spi;
    //Encoder* encoder;
    //FSM* fsm;
    //State* menu;
    //int iter; // this is used to determine the state action
    //unsigned int numb; // zero based number of state actions
    unsigned int active; // number of the active preset
};

} // end namespace
#endif 
